// Protocol support file
// Based on Arduino sample https://github.com/EmanuelFeru/hoverboard-firmware-hack-FOC/blob/master/Arduino/hoverserial/hoverserial.ino
// From Emanuel FERU's hoverboard-firmware-hack-FOC firmware

#ifndef _FOC_PROTOCOL_H
#define _FOC_PROTOCOL_H

#define START_FRAME 0xABCD

// 串口命令信息                     
typedef struct {
   uint16_t start;                 // 开始帧头
   int16_t  steer;                  
   int16_t  speed;                 // 
   uint16_t checksum;
} SerialCommand;

// 串口的返回信息
typedef struct {
   uint16_t start;                  // 开始帧头
   int16_t  cmd1;                   // cmd1
   int16_t  cmd2;                   // cmd2
   int16_t  speedR_meas;            // 右轮测速
   int16_t  speedL_meas;            // 左轮测速
   int16_t  wheelR_cnt;             // 右轮计数
   int16_t  wheelL_cnt;             // 左轮计数
   int16_t  batVoltage;             // 电池电压
   int16_t  boardTemp;              // 板子温度
   uint16_t cmdLed;                 // LED命令
   uint16_t checksum;               // 校验位
} SerialFeedback;

#endif
